%define debug_package %{nil}
%define name mda
%define version 0.9.51
%define release 1

%if "%{_lib}" != "lib"
%define _libsuffix 64
%else
%define _libsuffix ""
%endif

Name: %name
Version: %version
Release: %release
Provides: mda
Obsoletes: mda
Source: ftp://millistream.com/sources/%{name}-%{version}.tar.gz
License: GPL
Group: Applications/Databases
URL: http://millistream.com
Vendor: Millistream Market Data AB
Packager: Henrik Holst <henrik.holst@millistream.com>
Summary: Feeds a sql server with data from Millistream
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
Requires: expat libmdf libhashit
BuildRequires: mariadb-devel postgresql-devel unixODBC-devel expat-devel libmdf-devel libhashit-devel systemd

%description
The %{name} package provides an application to feed a sql
server with data from Millistream

%prep
%setup -q

%build
make LIB_SUFFIX=%_libsuffix

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT LIB_SUFFIX=%_libsuffix
mkdir -p ${RPM_BUILD_ROOT}%{_unitdir}
cp debian/mda.service ${RPM_BUILD_ROOT}%{_unitdir}/mda.service
mkdir -p $RPM_BUILD_ROOT%{_mandir}/{man5,man8}
cp debian/mda.config.5 $RPM_BUILD_ROOT%{_mandir}/man5/
cp debian/mda.8 $RPM_BUILD_ROOT%{_mandir}/man8/

%clean
rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/groupadd -rf mda 2>/dev/null || :
/usr/sbin/useradd -rM -s /sbin/nologin -g mda -d / mda 2>/dev/null || :

%post
if [ ! -e /etc/mda.tabledef ] ; then
	cp /usr/share/doc/mda/mda.tabledef /etc/mda.tabledef
fi
%systemd_post mda.service

%preun
if [ $1 -eq 0 ] ; then
	rm -rf /etc/mda.tabledef
fi
%systemd_preun mda.service

%postun
%systemd_postun_with_restart mda.service

%files
%defattr(-,root,root)
%doc /usr/share/doc/mda/*.sql
%ghost /etc/mda.tabledef
%attr(644, root, root) /usr/share/doc/mda/mda.tabledef
%attr(750, root, root) %{_prefix}/bin/mda
%attr(640, root, root) %{_libdir}/mda/*
%attr(600, root, root) %config(noreplace) /etc/mda.config
%attr(644, root, root) %config(noreplace) /etc/apparmor.d/usr.bin.mda
%attr(755, root, root) %{_unitdir}/mda.service
%{_mandir}/man5/*
%{_mandir}/man8/*

%changelog
* Thu Nov 01 2018 Henrik Holst <henrik.holst@millistream.com>
- Added unixODBC-devel to the build dependencies for the new odbc module

* Thu Jan 31 2017 Henrik Holst <henrik.holst@millistream.com>
- Add manpage for mda

* Thu Aug 25 2016 Henrik Holst <henrik.holst@millistream.com>
- Create system user and group to run MDA under

* Thu Nov 06 2014 Henrik Holst <henrik.holst@millistream.com>
- Added systemd support

* Thu Jun 03 2014 Henrik Holst <henrik.holst@millistream.com>
- No longer upgrade the SQL-database on upgrade
- Never overwrite /etc/mda.tabledef on upgrade

* Fri May 10 2013 Henrik Holst <henrik.holst@millistream.com>
- Automatically upgrade the SQL-database on upgrade
- Restart on upgrade

* Fri Apr 29 2011 Henrik Holst <henrik.holst@millistream.com>
- New names for the mdf and hashit dependencies

* Fri Mar 12 2010 Henrik Holst <henrik.holst@millistream.com>
- Corrected build and run dependencies

* Tue Mar 09 2010 Henrik Holst <henrik.holst@millistream.com>
- Build correctly on 64-bit systems

* Wed Mar 03 2010 Henrik Holst <henrik.holst@millistream.com>
- Install Red Hat specific init script

* Tue Dec 15 2009 Henrik Holst <henrik.holst@millistream.com>
- Install /etc/mda.config not readable by others
- Install /etc/init.d/mda not executable and writable by others
- Changed description from postgresql to generic sql server

* Mon Aug 27 2009 Henrik Holst <henrik.holst@millistream.com>
- Do not overwrite the config and tabledef files

* Mon Jan 20 2009 Henrik Holst <henrik.holst@millistream.com>
- First draft of the spec file
